var SchedMajorTick;
var SchedMinorTick;

var host = location.host;
var date = control.findById("D1").value;
var wo_id = control.findById("L2").value;

//var UserId = SFU.getUserLookupExtendedInformation(SFU.getVirtualActorId())['UserId'];
SchedMajorTick = control.findById("L8").displayValue;
SchedMinorTick = control.findById("L8").value;
var isResize = 0;
var isEdited = 0;
var isDataCorrect = 1 ;

var scheduler = $("#schedulerS1").data("kendoScheduler");
scheduler.bind("save", scheduler_save);
scheduler.bind("edit", scheduler_edit);
scheduler.bind("dataBound", scheduler_dataBound);
scheduler.bind("resizeEnd", scheduler_resize);
var options = scheduler.options;
options.startTime = new Date(date);
options.majorTick= SchedMajorTick;
//options.minorTickCount = SchedMinorTick;
options.columnWidth = SchedMinorTick;
build_scheduler(scheduler);

function build_scheduler(scheduler)
{
var Param = {};
var ParamsArray = [];
var ParamWO;
var POdata = [];
var listPO =[];
var arrWO =[];
var count = 0;
var startdate;
var enddate;
var jobTitle;
isResize = 0;
isEdited = 0;
var newReqQty =0;
var oldReqQty =0;
isDataCorrect = 1 ;
  
  
ParamsArray = [];
ParamWO = wo_id.replace(/;#/gi,",");
//1st Parameter to the command
Param.FieldName = "wo_id";
Param.Value = ParamWO;
Param.DataType = "string";
//ParamsArray.push(Param);

//Param = {};
Param.FieldName = "user_name";
Param.Value = UserId;
Param.DataType = "string";
//ParamsArray.push(Param);

//Param = {};
Param.FieldName = "scheduledate";
Param.Value = date;
Param.DataType = "string";

ParamsArray.push(Param);
console.log("Get Schedule Parameter : "+JSON.stringify(ParamsArray));
control.findByXmlNode("PanelJobView").visible = false;
control.findByXmlNode("GridJobView").visible = false;
control.findById("F8").buttonText = "Show Filter";


$.ajaxSetup({ cache: true});
$.ajax( {
  url: "http://"+host+"/MDMToolkit//api/MESLookup?ObjectName=MDM_Sched_Get_ScheduledJob&Command=GetByKey&filterParams="+
  JSON.stringify(ParamsArray),
  contentType: "application/jsonp; charset=utf-8",
  async:false,
  dataType: "json",
  success: function (records)
  {
    POdata = records;
  },
  error: function (err)
  {
    console.log('err:'+err.responseText);
  }
});

for(var k=0;k<POdata.length;k++)
{
  if(POdata[k].is_downtime_exists == 1)
  {
    jobTitle = "* "+POdata[k].job_priority+ " : "+POdata[k].wo_id + " : "+POdata[k].item_id +" : "+POdata[k].req_qty;
  }
  else
  {
    jobTitle = POdata[k].job_priority+ " : "+POdata[k].wo_id + " : "+POdata[k].item_id +" : "+POdata[k].req_qty;
  }
  listPO.push({id:POdata[k].row_id, start: POdata[k].job_latest_start_time, end: POdata[k].job_req_finished_time , 
               job_id: POdata[k].oper_id, wo_id:POdata[k].wo_id,mo_id:POdata[k].mo_id,title:jobTitle, item_id:POdata[k].item_id,oper_id:POdata[k].oper_id,
               ent_name:POdata[k].job_sched_entity_name,priority:POdata[k].job_priority ,req_qty:POdata[k].req_qty,req_qty_original:POdata[k].req_qty,job_seq_no:POdata[k].job_seq_no,
               job_sched_entity_id:POdata[k].job_sched_entity_id,splited_qty:0,new_job_entName:0,is_downtime_exists:POdata[k].is_downtime_exists,
               job_state:POdata[k].job_state,wo_state:POdata[k].wo_state});
}
var dataSource = new kendo.data.SchedulerDataSource({
  sync: dataSource_sync(),
  data: listPO
});
scheduler.setDataSource(dataSource);

if(initialJVLoad === true)//add code scheduler destroy for resources.
{
  initialJVLoad = false;
  for(  count = 0 ;count < POdata.length ;count++)
  { 
    if(arrWO.indexOf(POdata[count].oper_id) == -1)
    {
      arrWO.push(POdata[count].oper_id);
      scheduler.resources[0].dataSource.add({text: POdata[count].oper_id, value: POdata[count].oper_id ,color: "#6eb3fa" });
    }
  }
}


$("#schedulerS1").kendoTooltip({
      filter: ".k-event:not(.k-event-drag-hint) > div, .k-task",
      position: "top",
      width: 250,
      content: kendo.template("#var element = target.is(\".k-task\") ? target : target.parent();#   #var uid = element.attr(\"data-uid\");#  #var scheduler = target.closest(\"[data-role=scheduler]\").data(\"kendoScheduler\");#  #var model = scheduler.occurrenceByUid(uid);#  #if(model) {#      <strong>event start:</strong> #=kendo.format('{0:d}',model.start)#<br />      <strong>event end:</strong> #=kendo.format('{0:d}',model.end)#<br />      <strong>Seq No:</strong> #=model.job_seq_no#<br />  #} else {#      <strong>No event data is available</strong>  #}# ")
    });





  scheduler.view(scheduler.view().name);
  scheduler.date(new Date(date));


}



function dataSource_sync(e)
{
  //alert("SYNC");
  scheduler.dataSource.read();
  
}

function scheduler_resize(e)
{
  //alert("RESIZE");
  debugger;
  isResize = 1;
  startdate = new Date(e.event.start);
  enddate = new Date(e.event.end);
}


function scheduler_edit(e)
{
  //alert("EDIT");
  oldReqQty = e.event.req_qty;
  isEdited = 1;
}


function scheduler_dataBound(e)
{
  //alert("DATA BOUND");
  var view = this.view();
  var events = this.dataSource.view();
  var eventElement;
  var event;

  var checkColorSelector = $(".color-panel-selector").val();

  function getColor(checkval,checkColorSelector) {
    var MaxID = $(".form-container[id='1']").attr("data-row-id");

    for(var i=1; i<=MaxID; i++)
    {
      var StartVal = $("#StartVal[seq='"+i+"'").val();
      var EndVal = $("#EndVal[seq='"+i+"'").val(); 
      var EnumVal = $(".color-enumerator[seq='"+i+"'").val();
      if(checkColorSelector == "Job State"||checkColorSelector == "MO")
      {
        if(checkval==EnumVal)
        {

          return $(".form-container[id='"+i+"'] #color4").attr("value");
        }
      }
      else
      {
        if(checkval > StartVal && checkval <= EndVal)
        {
          return $(".form-container[id='"+i+"'] #color4").attr("value");
        }
      }
    }
    return '#000000';
  }
  for (var idx = 0, length = events.length; idx < length; idx++) {
    event = events[idx];
    //get event element
    eventElement = view.element.find("[data-uid=" + event.uid + "]");
    //set the backgroud of the element

    if (checkColorSelector == "Priority")
    {
      eventElement.css("background-color", getColor(event.priority,checkColorSelector));
    }
    else if (checkColorSelector == "Job State")
    {
      eventElement.css("background-color", getColor(event.job_state,checkColorSelector));
    }
    else
    {
      eventElement.css("background-color", getColor(event.mo_id,checkColorSelector));
    }

  }
}

function scheduler_save(e) {
  var startDate = new Date();
  var req_qty =0;
  var splited_qty =0;
  
// Do your operations
	
  var isSplit = 0;
  var isMerge = 0;
  var elementExists = document.getElementById("curReqQty");
  
  
  if (elementExists)
  {
       req_qty = parseInt(document.getElementById('curReqQty').value);
       splited_qty = parseInt(document.getElementById('toSplitQty').value);
  }
  else
  {
    	req_qty = 	e.event.req_qty;
        splited_qty = e.event.splited_qty;
  }

  if (document.getElementById('jobModify')!== null && document.getElementById('jobModify').checked) {

  }
  if (document.getElementById('jobSplit')!== null &&document.getElementById('jobSplit').checked) {
    isSplit = 1;
    isMerge = 0;
    var totQty = splited_qty + req_qty;
    if (totQty !== oldReqQty)
    {
      
      SFU.showError("Quantity Error", "sum of new required quantity and split quantity must be equal to old required quantity ",
      function()
      {
        isDataCorrect = 0;
      //enter code to perform actions after the error message is displayed.
      },
      "");
    }
  }
  if (document.getElementById('jobMerge')!== null &&document.getElementById('jobMerge').checked) {
    isMerge = 1;
    isSplit = 0;
  }

  if (e.event.splited_qty === null)
  {
    e.event.splited_qty = 0;
  }

  newReqQty = req_qty ;
  if (isResize === 1)
  {
    var timeDiff1 = Math.abs(e.event.end.getTime() - e.event.start.getTime());
    var timeDiff2 = Math.abs(enddate.getTime() - startdate.getTime());
    var newQty = Math.round((e.event.req_qty *timeDiff1)/timeDiff2);
    newReqQty = newQty;
  }

  if (isEdited === 1)
  {
    var qtyRatio = (newReqQty/oldReqQty).toFixed(2);
    if ( qtyRatio > 2.0)
    {
      isDataCorrect = 0;
      SFU.showError("Quantity Error", "New Quantity must be between -100% to +100% ",
      function()
      {
        isEdited = 0;
      //enter code to perform actions after the error message is displayed.
      },
      "");
    }
  }
  

  if(isDataCorrect === 1)
  {
    var ParamsArray = [];
    //1st Parameter to the command
    var Param = {};
    Param.FieldName = "wo_id";
    Param.Value = e.event.wo_id;
    Param.DataType = "string";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);
    //2nd Parameter to the command
    Param = {};
    Param.FieldName = "user_name";
    Param.Value = UserId;
    Param.DataType = "string";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "entId";
    Param.Value = e.event.job_sched_entity_id;
    Param.DataType = "int";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "operId";
    Param.Value = e.event.oper_id;
    Param.DataType = "string";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "priority";
    Param.Value = e.event.priority;
    Param.DataType = "int";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "starttime";
    Param.Value = SFU.getDateTimeInStringFormat(e.event.start, "yyyy-MM-dd HH:mm:ss");
    Param.DataType = "string";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "endtime";
    Param.Value = SFU.getDateTimeInStringFormat(e.event.end, "yyyy-MM-dd HH:mm:ss");
    Param.DataType = "string";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "reqQty";
    Param.Value = newReqQty;
    Param.DataType = "int";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "splitQty";
    Param.Value = splited_qty;
    Param.DataType = "int";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "jobSeqNo";
    Param.Value = e.event.job_seq_no;
    Param.DataType = "int";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "mergeJobSeq";
    Param.Value = e.event.new_job_entName;
    Param.DataType = "int";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "isSplit";
    Param.Value = isSplit;
    Param.DataType = "int";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);

    Param = {};
    Param.FieldName = "isMerge";
    Param.Value = isMerge;
    Param.DataType = "int";
    //Adding Param object to ParamsArray
    ParamsArray.push(Param);
    
    
   
    
    
    $.ajax({
      url: "http://"+host+"/MDMToolkit//api/MESLookup?ObjectName=MDM_Sched_Update_Scheduled_Job&Command=GetByKey&filterParams="+ JSON.stringify(ParamsArray),
      contentType: "application/jsonp; charset=utf-8",
      async:false,
      dataType: "json",
      success: function (result)
      {	
                            
      
        if(e.event.is_downtime_exists == 1)
        {
          jobTitle = "* "+e.event.priority+ " : "+e.event.wo_id + " : "+e.event.item_id +" : "+newReqQty;
        }
        else
        {
          jobTitle = e.event.priority+ " : "+e.event.wo_id + " : "+e.event.item_id +" : "+newReqQty;
        }
        e.event.set("title",jobTitle);
        var scheduler = $("#schedulerS1").data("kendoScheduler");
        scheduler.dataSource.sync();
                                      
        //scheduler.view(scheduler.view().name);
      },
      error: function (err)
      {
        console.log(err.responseText);
      }
    });
	
	build_scheduler(scheduler);
  }
}